SRPKeyPairRawCodec (GNU cryptographic primitives and tools)
Keywords: gnu.crypto.key.srp6.SRPKeyPairRawCodec,SRPKeyPairRawCodec class

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## gnu.crypto.key.srp6
Class SRPKeyPairRawCodec

    java.lang.Object
      |
      +--gnu.crypto.key.srp6.SRPKeyPairRawCodec

All Implemented Interfaces:
  IKeyPairCodec

public class SRPKeyPairRawCodec
extends java.lang.Object
implements IKeyPairCodec

An object that implements the `IKeyPairCodec` operations for the Raw format to use with SRP keypairs.

Reference:

1. SRP Protocol Design
   Thomas J. Wu.

Field Summary

Fields inherited from interface gnu.crypto.key.IKeyPairCodec
`RAW_FORMAT`

Constructor Summary
`SRPKeyPairRawCodec()`

Method Summary
`java.security.PrivateKey` | `decodePrivateKey(byte[] k)` Decodes an instance of an external private key into its native Java representation.
`java.security.PublicKey` | `decodePublicKey(byte[] k)` Decodes an instance of an external public key into its native Java representation.
`byte[]` | `encodePrivateKey(java.security.PrivateKey key)` Returns the encoded form of the designated SRP private key according to the Raw format supported by this library.
`byte[]` | `encodePublicKey(java.security.PublicKey key)` Returns the encoded form of the designated SRP public key according to the Raw format supported by this library.
`int` | `getFormatID()` Returns the unique identifier (within this library) of the format used to externalise public and private keys.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SRPKeyPairRawCodec

    public SRPKeyPairRawCodec()

Method Detail

### getFormatID

    public int getFormatID()

  Description copied from interface: `IKeyPairCodec`

  Returns the unique identifier (within this library) of the format used to externalise public and private keys.

  Specified by:
    `getFormatID` in interface `IKeyPairCodec`
  Returns:
    the identifier of the format, the object supports.

### encodePublicKey

    public byte[] encodePublicKey(java.security.PublicKey key)

  Returns the encoded form of the designated SRP public key according to the Raw format supported by this library.

  The Raw format for an SRP public key, in this implementation, is a byte sequence consisting of the following:

  1. 4-byte magic consisting of the value of the literal `Registry.MAGIC_RAW_SRP_PUBLIC_KEY`,
  3. 1-byte version consisting of the constant: 0x01,
  4. 4-byte count of following bytes representing the SRP parameter `N` in internet order,
  5. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the SRP parameter `N`,
  6. 4-byte count of following bytes representing the SRP parameter `g`,
  7. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the SRP parameter `g`,
  8. 4-byte count of following bytes representing the SRP parameter `y`,
  9. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the SRP parameter `y`,

  Specified by:
    `encodePublicKey` in interface `IKeyPairCodec`
  Parameters:
    `key` - the key to encode.
  Returns:
    the Raw format encoding of the designated key.
  Throws:
    `java.lang.IllegalArgumentException` - if the designated key is not an SRP one.

### decodePublicKey

    public java.security.PublicKey decodePublicKey(byte[] k)

  Description copied from interface: `IKeyPairCodec`

  Decodes an instance of an external public key into its native Java representation.

  Specified by:
    `decodePublicKey` in interface `IKeyPairCodec`
  Parameters:
    `k` - the source of the externalised key to decode.
  Returns:
    a concrete instance of a public key, reconstructed from the designated input.

### encodePrivateKey

    public byte[] encodePrivateKey(java.security.PrivateKey key)

  Returns the encoded form of the designated SRP private key according to the Raw format supported by this library.

  The Raw format for an SRP private key, in this implementation, is a byte sequence consisting of the following:

  1. 4-byte magic consisting of the value of the literal `Registry.MAGIC_RAW_SRP_PRIVATE_KEY`,
  3. 1-byte version consisting of the constant: 0x01,
  4. 4-byte count of following bytes representing the SRP parameter `N` in internet order,
  5. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the SRP parameter `N`,
  6. 4-byte count of following bytes representing the SRP parameter `g`,
  7. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the SRP parameter `g`,
  8. 4-byte count of following bytes representing the SRP parameter `x`,
  9. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the SRP parameter `x`,
  10. one byte which indicates whether the SRP parameter `v` is included in this encoding (value `0x01`) or not (value `0x00`).
  11. 4-byte count of following bytes representing the SRP parameter `v`,
  12. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the SRP parameter `v`,

  Specified by:
    `encodePrivateKey` in interface `IKeyPairCodec`
  Parameters:
    `key` - the key to encode.
  Returns:
    the Raw format encoding of the designated key.
  Throws:
    `java.lang.IllegalArgumentException` - if the designated key is not an SRP one.

### decodePrivateKey

    public java.security.PrivateKey decodePrivateKey(byte[] k)

  Description copied from interface: `IKeyPairCodec`

  Decodes an instance of an external private key into its native Java representation.

  Specified by:
    `decodePrivateKey` in interface `IKeyPairCodec`
  Parameters:
    `k` - the source of the externalised key to decode.
  Returns:
    a concrete instance of a private key, reconstructed from the designated input.

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001, 2002, 2003, 2004 Free Software Foundation, Inc.